﻿@model Taxonomy
@*@model TaxonomyTreeViewModel

    @{
        var Taxonomy = Model.Taxonomy;
        var JsTree = Model.JsTree;
    }*@

<div class="loading-bar">
</div>

<style>
    .loading-bar {
        display: none; 
        position: fixed;
        z-index : 1000; 
        left: 0;
        top: 0; 
        width: 100%; 
        height: 100%; 
        background-image: url('http://i.stack.imgur.com/FhHRx.gif');
        background-position: 50% 50%;
        background-color: rgba(255, 255, 255, 0.8);
        background-repeat: no-repeat;
    }

    body.loading {
        overflow: hidden;
    }

    body.loading .loading-bar {
        display: block;
    }
</style>


@section Head  {
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.2.1/themes/default/style.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/css/toastr.css" />

}

@section Scripts {
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/1.12.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.2.1/jstree.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>
    
    <script src="~/js/jstreegrid.js"></script>
    <script src="~/js/Objectid.js"></script>

    <script>
        toastr.options = {
          "debug": false,
          "positionClass": "toast-bottom-right",
          "onclick": null,
          "fadeIn": 300,
          "fadeOut": 1000,
          "timeOut": 5000,
          "extendedTimeOut": 1000
        }
        $(function () {

            $('#treeDiv').jstree({
                'core': {
                    'data': {
                        'url': '/Taxonomy/Nodes?processName=' + '@Model.ProcessName',
                        'data': function (node) {
                            return { 'id': node.id };
                        }
                    },

                    'check_callback': function (operation, node, node_parent, node_position, more) {
                        if (operation == "move_node") {
                            
                            if (is_leaf(node_parent.id) && has_reviews(node_parent.id)) {
                                toastr.error("Cannot move this node under a leaf");
                                return false;
                            }
                            return true;

                        }

                        return true;
                    },
                    'defaults': {
                        'checkbox': {
                            'whole_node': false
                        }
                    }
                },
                'plugins': ['checkbox', 'dnd', 'wholerow', 'contextmenu', 'grid'],
                grid: {
                    columns: [{ tree: true, header: "tree", width: 600 },
                        { header: "#Rev", width: 75, value: function (node) { return node.data.reviewCount } },
                        { header: "Keywords", width: 500, value: function (node) { return node.data.keywords} }, 
                        //{ header: "Id", width: 200, value: function (node) { return node.id } }
                    ]
                },
                'checkbox': {
                    'three_state': false
                },
                'dnd': {
                    check_while_dragging: false,
                },
                'contextmenu': {
                    'items': function ($node) {
                        var tree = $("#treeDiv").jstree(true);
                        return {
                            "See Reviews": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "See Reviews",
                                action: function (obj) {
                                    if (!is_leaf($node.id)) {
                                        toastr.error('Only leaf nodes have reviews');
                                    }
                                    else {
                                        var newWindow = window.open('/Taxonomy/SeeReviews?taxonomyId=' + $node.id + '&rootId=' + '@Model.Id', $node.text, "height=500,width=800, status=yes,toolbar=yes,menubar=yes,location=yess");
                                        newWindow.addEventListener('load', function () {
                                            newWindow.document.title = $node.text;
                                        });
                                    }
                                }
                            },
                            "Cluster": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "Cluster",
                                action: function (obj) {
                                    // CLUSTER ACTION GOES HERE

                                    if (!is_leaf($node.id)) {
                                        toastr.error("Only leaf nodes are clusterable");
                                    }
                                    else {
                                        window.open("/Taxonomy/ClusterMore?taxonomyId=" + $node.id + "&rootId=" + '@Model.Id' + '&processName=' + '@Model.ProcessName');
                                    }
                                }
                            },
                            "Merge": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "Merge Selected Nodes",
                                action: function (obj) {
                                    let nodes = get_checked_nodes_ids();
                                    if (nodes.length < 2) {
                                        toastr.error("Select at least 2 taxonomies");
                                    }
                                    else if (!are_siblings(nodes)) {
                                        toastr.error("Only siblings can be merged");
                                    }
                                    else {

                                        if (all_leaves(nodes)) {
                                            //toastr.info("mearging leaves");
                                            let url = '/Taxonomy/Merge?rootId=' + '@Model.Id' + '&mergingLeaves=true';

                                            for (var node of nodes) {
                                                url += "&taxonomyIds=" + node;
                                            }
                                            var newWindow = window.open(url);

                                        }
                                        else if (all_non_leaves(nodes)) {
                                            //toastr.info("merging nodes");
                                            let url = '/Taxonomy/Merge?rootId=' + '@Model.Id' + '&mergingLeaves=false';

                                            for (var node of nodes) {
                                                url += "&taxonomyIds=" + node;
                                            }
                                            var newWindow = window.open(url);
                                        }
                                        else {
                                            toastr.error("Cannot merge a leaf with a node");
                                        }
                                    }
                                }
                            },
                            "Create": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "Create Child Node",
                                action: function (obj) {
                                    if (is_leaf($node.id)) {
                                        toastr.error("Cannot create child for a leaf");
                                    }

                                    else {
                                        let newId = new ObjectId().toString();
                                        $node = tree.create_node($node, { text: "New Node", id: newId, data: {reviewCount: 0, keywords: ""} });
                                        
                                        
                                        tree.deselect_all();
                                        tree.select_node($node);
                                    }

                                }
                            },
                            "Rename": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "Rename",
                                action: function (obj) {
                                    tree.edit($node);
                                }
                            },
                            "Delete": {
                                "separator_before": false,
                                "separator_after": false,
                                "label": "Delete",
                                action: function (obj) {
                                    tree.delete_node($node);
                                }
                            }
                        }
                    }
                }
            }).bind("move_node.jstree", function (e, data) {
                const ajax = new XMLHttpRequest();
                let url = "/Taxonomy/Move?taxonomyId=" + data.node.id + "&rootId=" + '@Model.Id' + "&newParentId=" + data.parent;
                ajax.open("GET", url);
                document.body.className = "loading";
                ajax.send();    
                ajax.onreadystatechange = function () {
                    if (this.readyState == 4 && this.status == 200) {
                        document.body.className = "skin-blue sidebar-mini";
                        toastr.success("Move successful");
                    }
                }
            }
            );

            $("#treeDiv").on('rename_node.jstree', function (e, data) {
                const ajax = new XMLHttpRequest();
                const url = "/Taxonomy/Rename?rootId=" + '@Model.Id' + "&taxonomyId=" + data.node.id + "&newName=" + data.text;
                ajax.open("GET", url);
                document.body.className = "loading";
                ajax.send();
                ajax.onreadystatechange = function () {
                    if (this.readyState == 4 && this.status == 200) {
                        document.body.className = "skin-blue sidebar-mini";
                        toastr.success("Rename successful");
                    }
                }
            });

            $("#treeDiv").on('delete_node.jstree', function (e, data) {
                
                
                const ajax = new XMLHttpRequest();
                const url = "/Taxonomy/DeleteSubtree?rootId=" + '@Model.Id' + "&taxonomyId=" + data.node.id;
                ajax.open("GET", url);
                document.body.className = "loading";
                ajax.send();
                ajax.onreadystatechange = function () {
                    if (this.readyState == 4 && this.status == 200) {
                        document.body.className = "skin-blue sidebar-mini";
                        toastr.success("Node deletion successful");
                    }
                }
            });

            $("#treeDiv").on('create_node.jstree', function (e, data) {
                
                let parentId = data.node.parent;
                let nodeName = data.node.original.text;
                let newId = data.node.id;
                const ajax = new XMLHttpRequest();
                const url = "/Taxonomy/Create?rootId=" + '@Model.Id' + "&parentId=" + parentId + "&nodeName=" + nodeName + "&newId=" + newId;
                ajax.open("GET", url);
                document.body.className = "loading";
                ajax.send();
                ajax.onreadystatechange = function () {
                    if (this.readyState == 4 && this.status == 200) {
                        document.body.className = "skin-blue sidebar-mini";
                        toastr.success("Node creation successful");
                    }
                }
            });

            


            $('#treeDiv').on('changed.jstree', function (e, data) {
                      var i, j, r = [];
                      for (i = 0, j = data.selected.length; i < j; i++) {
                          r.push(data.instance.get_node(data.selected[i]).text);
                      }
                      //alert('Selected: ' + r.join(', '));
                  }).jstree();
        });

        $.jstree.defaults.dnd.drag_selection = false;
        $.jstree.defaults.contextmenu.select_node = false;
        $(document).bind("dnd_start.vakata", function(e, data) {
            //console.log("Start dnd");
            //let id = data.data.nodes[0];
            //let node = get_node_by_id(id);
            //console.log(node.parent);
        })
        .bind("dnd_move.vakata", function(e, data) {
            //console.log("Move dnd");
        })
        .bind("dnd_stop.vakata", function(e, data) {
            //console.log("Stop dnd");
            //let id = data.data.nodes[0];
            //let node = get_node_by_id(id);
            //console.log(node.parent);
        });



        //$("#treeDiv").jstree({
        //    // tree...
        //}).bind("move_node.jstree", function(e, data) {
        //   console.log("Drop node " + data.node.id + " to " + data.parent);
        //});
        function get_all_nodes_ids() {
            let nodes = $("#treeDiv").jstree(true).get_json("#", { flat: true });
            let node_ids = nodes.map(x => x.id);
            return node_ids;
        }

        function get_node_by_id(id) {
            let nodes = $("#treeDiv").jstree(true).get_json("#", { flat: true });
            let node = nodes.filter(x => x.id == id)[0];
            return node;
        }

        function has_reviews(id) {
            let node = get_node_by_id(id);
            return node.data.reviewCount > 0;
        }


        function get_leaves() {
            let nodes = $("#treeDiv").jstree(true).get_json("#", { flat: true });
            let node_ids = nodes.map(x => x.id);
            let node_parents = nodes.map(x => x.parent);
            let res = [];
            for (var id of node_ids) {
                if (!node_parents.includes(id)) {
                    res.push(id);
                }
            }
            return res;
        }

        function is_leaf(id) {
            return get_leaves().includes(id);
        }

        function all_leaves(ids) {
            for (var id of ids) {
                if (!is_leaf(id))
                    return false;
            }
            return true;
        }

        function all_non_leaves(ids) {
            for (var id of ids) {
                if (is_leaf(id))
                    return false;
            }
            return true;
        }

        function parent_id(node_id) {
            let nodes = $("#treeDiv").jstree(true).get_json("#", { flat: true });
            let my_node = nodes.filter(x => x.id == node_id)[0];
            return my_node.parent;
        }

        function get_checked_nodes_ids() {
            return $("#treeDiv").jstree("get_checked", null, true);
        }

        function are_siblings(node_ids) {
            let parents = [];
            for (var node_id of node_ids) {
                let parent = parent_id(node_id);
                if (!parents.includes(parent)) {
                    parents.push(parent);
                }
            }
            return parents.length == 1;
        }


    </script>
}



<section class="content-header">
    <h1>
        Taxonomy
        <small>List</small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Level</a></li>
        <li class="active">Here</li>
    </ol>
</section>
<section class="content">
    <div class="row">
        <!-- left column -->
        <div class="col-xs-12">
            <div class="box">
                <div class="box-header">
                    <h3 class="box-title">Taxonomy</h3>
                    <div class="box-tools">
                        @*<div class="input-group input-group-sm" style="width: 150px;">
                            <input type="text" name="table_search" class="form-control pull-right" placeholder="Search">

                            <div class="input-group-btn">
                                <button type="submit" class="btn btn-default"><i class="fa fa-search"></i></button>
                            </div>
                        </div>*@
                        <a asp-controller="Taxonomy" asp-action="Train" asp-route-rootId="@Model.Id" class="btn btn-primary">Train Classifiers for This Tree</a>
                    </div>
                </div>
                <!-- /.box-header -->
                <div class="box-body table-responsive">
                    <div id="treeDiv"></div>
                    @*<form method="post" asp-controller="Topic" asp-action="TopicAction">
                            <table class="table table-hover">
                                <tbody>
                                    <tr>
                                        <th>Select</th>
                                        <th>ID</th>
                                        <th>Name</th>
                                        <th>Keywords</th>
                                        <th>Count</th>
                                        <th>Status</th>
                                        <th>records</th>
                                    </tr>
                                    @foreach (var t in Model.OrderBy(x => x.Status))
                                    {
                                        <tr>
                                            <td><input type="checkbox" name="selectedTopics" value="@t.Id" /></td>
                                            <td>@t.TopicId</td>
                                            <td>@t.Name</td>
                                            <td>@string.Join(", ", t.Keywords)</td>
                                            <td>@t.ReviewsCount</td>
                                            <td>@t.Status</td>
                                            <td><a href="~/Topic/ReviewList/@t.Id" target="_blank">Reviews</a></td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                            <div class="col-xs-4">
                                <select class="form-control" name="action">
                                    <option value="merge">Merge Selected Topics</option>
                                    <option value="group">Group Selected Topics</option>
                                </select>
                            </div>
                            <div class="col-xs-4">
                                <input type="text" class="form-control" placeholder="New Topic Name" name="newName">
                            </div>
                            <button type="submit" class="btn btn-primary">Submit</button>

                        </form>*@

                </div>
                <!-- /.box-body -->
            </div>
            <!-- /.box -->
        </div>

    </div>
    <!-- /.row -->
</section>